package com.helix.tasks.service.base;

import com.helix.tasks.model.Events;
import com.helix.tasks.service.EventsLocalService;
import com.helix.tasks.service.persistence.EventsPersistence;
import com.helix.tasks.service.persistence.SourcePersistence;

import com.liferay.portal.kernel.bean.BeanReference;
import com.liferay.portal.kernel.bean.IdentifiableBean;
import com.liferay.portal.kernel.dao.jdbc.SqlUpdate;
import com.liferay.portal.kernel.dao.jdbc.SqlUpdateFactoryUtil;
import com.liferay.portal.kernel.dao.orm.DynamicQuery;
import com.liferay.portal.kernel.dao.orm.DynamicQueryFactoryUtil;
import com.liferay.portal.kernel.dao.orm.Projection;
import com.liferay.portal.kernel.exception.PortalException;
import com.liferay.portal.kernel.exception.SystemException;
import com.liferay.portal.kernel.search.Indexable;
import com.liferay.portal.kernel.search.IndexableType;
import com.liferay.portal.kernel.util.OrderByComparator;
import com.liferay.portal.model.PersistedModel;
import com.liferay.portal.service.BaseLocalServiceImpl;
import com.liferay.portal.service.PersistedModelLocalServiceRegistryUtil;
import com.liferay.portal.service.persistence.UserPersistence;

import java.io.Serializable;

import java.util.List;

import javax.sql.DataSource;

/**
 * Provides the base implementation for the events local service.
 *
 * <p>
 * This implementation exists only as a container for the default service methods generated by ServiceBuilder. All custom service methods should be put in {@link com.helix.tasks.service.impl.EventsLocalServiceImpl}.
 * </p>
 *
 * @author Brian Wing Shun Chan
 * @see com.helix.tasks.service.impl.EventsLocalServiceImpl
 * @see com.helix.tasks.service.EventsLocalServiceUtil
 * @generated
 */
public abstract class EventsLocalServiceBaseImpl extends BaseLocalServiceImpl
    implements EventsLocalService, IdentifiableBean {
    @BeanReference(type = com.helix.tasks.service.EventsLocalService.class)
    protected com.helix.tasks.service.EventsLocalService eventsLocalService;
    @BeanReference(type = EventsPersistence.class)
    protected EventsPersistence eventsPersistence;
    @BeanReference(type = com.helix.tasks.service.SourceLocalService.class)
    protected com.helix.tasks.service.SourceLocalService sourceLocalService;
    @BeanReference(type = SourcePersistence.class)
    protected SourcePersistence sourcePersistence;
    @BeanReference(type = com.liferay.counter.service.CounterLocalService.class)
    protected com.liferay.counter.service.CounterLocalService counterLocalService;
    @BeanReference(type = com.liferay.portal.service.ResourceLocalService.class)
    protected com.liferay.portal.service.ResourceLocalService resourceLocalService;
    @BeanReference(type = com.liferay.portal.service.UserLocalService.class)
    protected com.liferay.portal.service.UserLocalService userLocalService;
    @BeanReference(type = com.liferay.portal.service.UserService.class)
    protected com.liferay.portal.service.UserService userService;
    @BeanReference(type = UserPersistence.class)
    protected UserPersistence userPersistence;
    private String _beanIdentifier;
    private ClassLoader _classLoader;
    private EventsLocalServiceClpInvoker _clpInvoker = new EventsLocalServiceClpInvoker();

    /*
     * NOTE FOR DEVELOPERS:
     *
     * Never modify or reference this class directly. Always use {@link com.helix.tasks.service.EventsLocalServiceUtil} to access the events local service.
     */

    /**
     * Adds the events to the database. Also notifies the appropriate model listeners.
     *
     * @param events the events
     * @return the events that was added
     * @throws SystemException if a system exception occurred
     */
    @Indexable(type = IndexableType.REINDEX)
    @Override
    public Events addEvents(Events events) throws SystemException {
        events.setNew(true);

        return eventsPersistence.update(events);
    }

    /**
     * Creates a new events with the primary key. Does not add the events to the database.
     *
     * @param eventId the primary key for the new events
     * @return the new events
     */
    @Override
    public Events createEvents(long eventId) {
        return eventsPersistence.create(eventId);
    }

    /**
     * Deletes the events with the primary key from the database. Also notifies the appropriate model listeners.
     *
     * @param eventId the primary key of the events
     * @return the events that was removed
     * @throws PortalException if a events with the primary key could not be found
     * @throws SystemException if a system exception occurred
     */
    @Indexable(type = IndexableType.DELETE)
    @Override
    public Events deleteEvents(long eventId)
        throws PortalException, SystemException {
        return eventsPersistence.remove(eventId);
    }

    /**
     * Deletes the events from the database. Also notifies the appropriate model listeners.
     *
     * @param events the events
     * @return the events that was removed
     * @throws SystemException if a system exception occurred
     */
    @Indexable(type = IndexableType.DELETE)
    @Override
    public Events deleteEvents(Events events) throws SystemException {
        return eventsPersistence.remove(events);
    }

    @Override
    public DynamicQuery dynamicQuery() {
        Class<?> clazz = getClass();

        return DynamicQueryFactoryUtil.forClass(Events.class,
            clazz.getClassLoader());
    }

    /**
     * Performs a dynamic query on the database and returns the matching rows.
     *
     * @param dynamicQuery the dynamic query
     * @return the matching rows
     * @throws SystemException if a system exception occurred
     */
    @Override
    @SuppressWarnings("rawtypes")
    public List dynamicQuery(DynamicQuery dynamicQuery)
        throws SystemException {
        return eventsPersistence.findWithDynamicQuery(dynamicQuery);
    }

    /**
     * Performs a dynamic query on the database and returns a range of the matching rows.
     *
     * <p>
     * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link com.helix.tasks.model.impl.EventsModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
     * </p>
     *
     * @param dynamicQuery the dynamic query
     * @param start the lower bound of the range of model instances
     * @param end the upper bound of the range of model instances (not inclusive)
     * @return the range of matching rows
     * @throws SystemException if a system exception occurred
     */
    @Override
    @SuppressWarnings("rawtypes")
    public List dynamicQuery(DynamicQuery dynamicQuery, int start, int end)
        throws SystemException {
        return eventsPersistence.findWithDynamicQuery(dynamicQuery, start, end);
    }

    /**
     * Performs a dynamic query on the database and returns an ordered range of the matching rows.
     *
     * <p>
     * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link com.helix.tasks.model.impl.EventsModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
     * </p>
     *
     * @param dynamicQuery the dynamic query
     * @param start the lower bound of the range of model instances
     * @param end the upper bound of the range of model instances (not inclusive)
     * @param orderByComparator the comparator to order the results by (optionally <code>null</code>)
     * @return the ordered range of matching rows
     * @throws SystemException if a system exception occurred
     */
    @Override
    @SuppressWarnings("rawtypes")
    public List dynamicQuery(DynamicQuery dynamicQuery, int start, int end,
        OrderByComparator orderByComparator) throws SystemException {
        return eventsPersistence.findWithDynamicQuery(dynamicQuery, start, end,
            orderByComparator);
    }

    /**
     * Returns the number of rows that match the dynamic query.
     *
     * @param dynamicQuery the dynamic query
     * @return the number of rows that match the dynamic query
     * @throws SystemException if a system exception occurred
     */
    @Override
    public long dynamicQueryCount(DynamicQuery dynamicQuery)
        throws SystemException {
        return eventsPersistence.countWithDynamicQuery(dynamicQuery);
    }

    /**
     * Returns the number of rows that match the dynamic query.
     *
     * @param dynamicQuery the dynamic query
     * @param projection the projection to apply to the query
     * @return the number of rows that match the dynamic query
     * @throws SystemException if a system exception occurred
     */
    @Override
    public long dynamicQueryCount(DynamicQuery dynamicQuery,
        Projection projection) throws SystemException {
        return eventsPersistence.countWithDynamicQuery(dynamicQuery, projection);
    }

    @Override
    public Events fetchEvents(long eventId) throws SystemException {
        return eventsPersistence.fetchByPrimaryKey(eventId);
    }

    /**
     * Returns the events with the primary key.
     *
     * @param eventId the primary key of the events
     * @return the events
     * @throws PortalException if a events with the primary key could not be found
     * @throws SystemException if a system exception occurred
     */
    @Override
    public Events getEvents(long eventId)
        throws PortalException, SystemException {
        return eventsPersistence.findByPrimaryKey(eventId);
    }

    @Override
    public PersistedModel getPersistedModel(Serializable primaryKeyObj)
        throws PortalException, SystemException {
        return eventsPersistence.findByPrimaryKey(primaryKeyObj);
    }

    /**
     * Returns a range of all the eventses.
     *
     * <p>
     * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link com.helix.tasks.model.impl.EventsModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
     * </p>
     *
     * @param start the lower bound of the range of eventses
     * @param end the upper bound of the range of eventses (not inclusive)
     * @return the range of eventses
     * @throws SystemException if a system exception occurred
     */
    @Override
    public List<Events> getEventses(int start, int end)
        throws SystemException {
        return eventsPersistence.findAll(start, end);
    }

    /**
     * Returns the number of eventses.
     *
     * @return the number of eventses
     * @throws SystemException if a system exception occurred
     */
    @Override
    public int getEventsesCount() throws SystemException {
        return eventsPersistence.countAll();
    }

    /**
     * Updates the events in the database or adds it if it does not yet exist. Also notifies the appropriate model listeners.
     *
     * @param events the events
     * @return the events that was updated
     * @throws SystemException if a system exception occurred
     */
    @Indexable(type = IndexableType.REINDEX)
    @Override
    public Events updateEvents(Events events) throws SystemException {
        return eventsPersistence.update(events);
    }

    /**
     * Returns the events local service.
     *
     * @return the events local service
     */
    public com.helix.tasks.service.EventsLocalService getEventsLocalService() {
        return eventsLocalService;
    }

    /**
     * Sets the events local service.
     *
     * @param eventsLocalService the events local service
     */
    public void setEventsLocalService(
        com.helix.tasks.service.EventsLocalService eventsLocalService) {
        this.eventsLocalService = eventsLocalService;
    }

    /**
     * Returns the events persistence.
     *
     * @return the events persistence
     */
    public EventsPersistence getEventsPersistence() {
        return eventsPersistence;
    }

    /**
     * Sets the events persistence.
     *
     * @param eventsPersistence the events persistence
     */
    public void setEventsPersistence(EventsPersistence eventsPersistence) {
        this.eventsPersistence = eventsPersistence;
    }

    /**
     * Returns the source local service.
     *
     * @return the source local service
     */
    public com.helix.tasks.service.SourceLocalService getSourceLocalService() {
        return sourceLocalService;
    }

    /**
     * Sets the source local service.
     *
     * @param sourceLocalService the source local service
     */
    public void setSourceLocalService(
        com.helix.tasks.service.SourceLocalService sourceLocalService) {
        this.sourceLocalService = sourceLocalService;
    }

    /**
     * Returns the source persistence.
     *
     * @return the source persistence
     */
    public SourcePersistence getSourcePersistence() {
        return sourcePersistence;
    }

    /**
     * Sets the source persistence.
     *
     * @param sourcePersistence the source persistence
     */
    public void setSourcePersistence(SourcePersistence sourcePersistence) {
        this.sourcePersistence = sourcePersistence;
    }

    /**
     * Returns the counter local service.
     *
     * @return the counter local service
     */
    public com.liferay.counter.service.CounterLocalService getCounterLocalService() {
        return counterLocalService;
    }

    /**
     * Sets the counter local service.
     *
     * @param counterLocalService the counter local service
     */
    public void setCounterLocalService(
        com.liferay.counter.service.CounterLocalService counterLocalService) {
        this.counterLocalService = counterLocalService;
    }

    /**
     * Returns the resource local service.
     *
     * @return the resource local service
     */
    public com.liferay.portal.service.ResourceLocalService getResourceLocalService() {
        return resourceLocalService;
    }

    /**
     * Sets the resource local service.
     *
     * @param resourceLocalService the resource local service
     */
    public void setResourceLocalService(
        com.liferay.portal.service.ResourceLocalService resourceLocalService) {
        this.resourceLocalService = resourceLocalService;
    }

    /**
     * Returns the user local service.
     *
     * @return the user local service
     */
    public com.liferay.portal.service.UserLocalService getUserLocalService() {
        return userLocalService;
    }

    /**
     * Sets the user local service.
     *
     * @param userLocalService the user local service
     */
    public void setUserLocalService(
        com.liferay.portal.service.UserLocalService userLocalService) {
        this.userLocalService = userLocalService;
    }

    /**
     * Returns the user remote service.
     *
     * @return the user remote service
     */
    public com.liferay.portal.service.UserService getUserService() {
        return userService;
    }

    /**
     * Sets the user remote service.
     *
     * @param userService the user remote service
     */
    public void setUserService(
        com.liferay.portal.service.UserService userService) {
        this.userService = userService;
    }

    /**
     * Returns the user persistence.
     *
     * @return the user persistence
     */
    public UserPersistence getUserPersistence() {
        return userPersistence;
    }

    /**
     * Sets the user persistence.
     *
     * @param userPersistence the user persistence
     */
    public void setUserPersistence(UserPersistence userPersistence) {
        this.userPersistence = userPersistence;
    }

    public void afterPropertiesSet() {
        Class<?> clazz = getClass();

        _classLoader = clazz.getClassLoader();

        PersistedModelLocalServiceRegistryUtil.register("com.helix.tasks.model.Events",
            eventsLocalService);
    }

    public void destroy() {
        PersistedModelLocalServiceRegistryUtil.unregister(
            "com.helix.tasks.model.Events");
    }

    /**
     * Returns the Spring bean ID for this bean.
     *
     * @return the Spring bean ID for this bean
     */
    @Override
    public String getBeanIdentifier() {
        return _beanIdentifier;
    }

    /**
     * Sets the Spring bean ID for this bean.
     *
     * @param beanIdentifier the Spring bean ID for this bean
     */
    @Override
    public void setBeanIdentifier(String beanIdentifier) {
        _beanIdentifier = beanIdentifier;
    }

    @Override
    public Object invokeMethod(String name, String[] parameterTypes,
        Object[] arguments) throws Throwable {
        Thread currentThread = Thread.currentThread();

        ClassLoader contextClassLoader = currentThread.getContextClassLoader();

        if (contextClassLoader != _classLoader) {
            currentThread.setContextClassLoader(_classLoader);
        }

        try {
            return _clpInvoker.invokeMethod(name, parameterTypes, arguments);
        } finally {
            if (contextClassLoader != _classLoader) {
                currentThread.setContextClassLoader(contextClassLoader);
            }
        }
    }

    protected Class<?> getModelClass() {
        return Events.class;
    }

    protected String getModelClassName() {
        return Events.class.getName();
    }

    /**
     * Performs an SQL query.
     *
     * @param sql the sql query
     */
    protected void runSQL(String sql) throws SystemException {
        try {
            DataSource dataSource = eventsPersistence.getDataSource();

            SqlUpdate sqlUpdate = SqlUpdateFactoryUtil.getSqlUpdate(dataSource,
                    sql, new int[0]);

            sqlUpdate.update();
        } catch (Exception e) {
            throw new SystemException(e);
        }
    }
}
